#include <bits\stdc++.h>
using namespace std;

int n, m, a[1000][1000];
long long ans;

void Step(int x, int y){
	int d = 0, r = 0;
	if(x == m && y == n){
		cout << ans;
		return;
	}
	for(int i = y+1; i < m; i++){
		for(int j = 0; j <= x; j++)d+=a[j][i];
	}
	for(int i = x+1; i < n; i++){
		for(int j = 0; j <= y; j++)r+=a[j][i];
	}
	if(r < d){
		ans+= r;
		Step(x+1, y);
		return;
	}else{
		ans+= d;
		Step(x, y+1);
		return;
	}
	return;
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int i, j;
	cin >> n >> m;
	
	for(i = 0; i < n; i++){
		for(j = 0; j < m; j++){
			cin >> a[i][j];
		}
	}
	
	if(n == 2){
		int sum1;
		for(i = m-2; i >= 0; i--){
			sum1 = 0;
			for(j = i-1; i >= 0; j--){
				sum1+= a[1][j];
			}
			if(sum1 > a[0][i])continue;
			for(j = i; j >= 0; j--){
				ans+= a[1][j] * (i-j + 1);
			}
			for(j = i+2; j < m; j++){
				ans+=a[0][j];
			}
		}
		cout << ans;
		return 0;
	}
	
	Step(0,0);
	
	return 0;
}